#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK40x0x40TN2x1x40_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=40, NB=0, KB=40, 
 * lda=40, ldb=40, ldc=0, mu=2, nu=1, ku=40, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.9.35)
 */
{
   #define Nb N
   const double *stM = A + 1600;
   const double *stN = B + (((Nb) << 5)+((Nb) << 3));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*1)/(40*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 40
   const int incAm = 40, incAn = -1600;
   #define incBk 40
   const int incBm = -40, incBn = 40;
   const int incAk0 = ((incAk) / 40), incBk0 = ((incBk) / 40);
   #define incCm 4
   const int incCn = (((ldc) << 1)) - 80;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0;
   register double m0, m1, m2, m3;
   register double rC0_0, rC1_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[2];
         rC1_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA1 = pA0[40];
         m1 = rA1 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[41];
         m2 = rA0 * rB0;
         m3 = rA1 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[42];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA0[43];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA0[44];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rA1 = pA0[45];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA0[46];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rA1 = pA0[47];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rA1 = pA0[48];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rA1 = pA0[49];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rA1 = pA0[50];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rA1 = pA0[51];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rA1 = pA0[52];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rA1 = pA0[53];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rA1 = pA0[54];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rA1 = pA0[55];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rA1 = pA0[56];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rA1 = pA0[57];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rA1 = pA0[58];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rA1 = pA0[59];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rA1 = pA0[60];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rA1 = pA0[61];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rA1 = pA0[62];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rA1 = pA0[63];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rA1 = pA0[64];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rA1 = pA0[65];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rA1 = pA0[66];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rA1 = pA0[67];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rA1 = pA0[68];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rA1 = pA0[69];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rA1 = pA0[70];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rA1 = pA0[71];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rA1 = pA0[72];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rA1 = pA0[73];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rA1 = pA0[74];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rA1 = pA0[75];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rA1 = pA0[76];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[37];
         rB0 = pB0[37];
         rA1 = pA0[77];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rA1 = pA0[78];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[39];
         rB0 = pB0[39];
         rA1 = pA0[79];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m0;
         rC1_0 += m1;
         rC0_0 += m2;
         rC1_0 += m3;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK40x0x40TN40x40x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=40, NB=0, KB=40, 
 * lda=40, ldb=40, ldc=0, mu=2, nu=2, ku=40, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.9.35)
 */
{
   const int Nb = (N>>1)<<1;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 1600;
   const double *stN = B + (((Nb) << 5)+((Nb) << 3));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*2)/(40*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 40
   const int incAm = 40, incAn = -1600;
   #define incBk 40
   const int incBm = -40, incBn = 80;
   const int incAk0 = ((incAk) / 40), incBk0 = ((incBk) / 40);
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 80;
   double *pC0=C, *pC1=pC0+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0, rB1;
   register double m0, m1, m2;
   register double rC0_0, rC1_0, rC0_1, rC1_1;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC1_1 = pC1[2];
            rC1_1 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            m0 = rA0 * rB0;
            rA1 = pA0[40];
            m1 = rA1 * rB0;
            rB1 = pB0[40];
            m2 = rA0 * rB1;

/*
 *          Completely unrolled K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[41];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[41];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[42];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[42];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[43];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[43];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[44];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[44];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[45];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[45];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[46];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[46];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[47];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[47];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[48];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[48];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[49];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[49];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[50];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[50];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[51];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[51];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[52];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[52];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rA1 = pA0[53];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[53];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rA1 = pA0[54];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[54];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rA1 = pA0[55];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[55];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rA1 = pA0[56];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[56];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rA1 = pA0[57];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[57];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rA1 = pA0[58];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[58];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rA1 = pA0[59];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[59];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rA1 = pA0[60];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[60];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rA1 = pA0[61];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[61];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[22];
            rB0 = pB0[22];
            rA1 = pA0[62];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[62];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[23];
            rB0 = pB0[23];
            rA1 = pA0[63];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[63];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[24];
            rB0 = pB0[24];
            rA1 = pA0[64];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[64];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[25];
            rB0 = pB0[25];
            rA1 = pA0[65];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[65];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[26];
            rB0 = pB0[26];
            rA1 = pA0[66];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[66];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[27];
            rB0 = pB0[27];
            rA1 = pA0[67];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[67];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[28];
            rB0 = pB0[28];
            rA1 = pA0[68];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[68];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[29];
            rB0 = pB0[29];
            rA1 = pA0[69];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[69];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[30];
            rB0 = pB0[30];
            rA1 = pA0[70];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[70];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[31];
            rB0 = pB0[31];
            rA1 = pA0[71];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[71];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[32];
            rB0 = pB0[32];
            rA1 = pA0[72];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[72];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[33];
            rB0 = pB0[33];
            rA1 = pA0[73];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[73];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[34];
            rB0 = pB0[34];
            rA1 = pA0[74];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[74];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[35];
            rB0 = pB0[35];
            rA1 = pA0[75];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[75];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[36];
            rB0 = pB0[36];
            rA1 = pA0[76];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[76];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rA0 = pA0[37];
            rB0 = pB0[37];
            rA1 = pA0[77];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rB1 = pB0[77];
            rC0_1 += m2;
            m2 = rA1 * rB0;
            rC1_1 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA1 * rB1;
            rA0 = pA0[38];
            rB0 = pB0[38];
            rA1 = pA0[78];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rB1 = pB0[78];
            rC0_1 += m0;
            m0 = rA1 * rB0;
            rC1_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m2;
            m2 = rA1 * rB1;
            rA0 = pA0[39];
            rB0 = pB0[39];
            rA1 = pA0[79];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[79];
            rC0_1 += m1;
            m1 = rA1 * rB0;
            rC1_1 += m2;
            m2 = rA0 * rB1;
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB1;
            rC1_0 += m1;
            rC0_1 += m2;
            rC1_1 += m0;
            pA0 += incAk;
            pB0 += incBk;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            *pC1 = rC0_1;
            pC1[2] = rC1_1;
            pC0 += incCm;
            pC1 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_zJIK40x0x40TN2x1x40_a1_bX(40, k, 40, alpha, ca, lda, cb + (((Nb) << 5)+((Nb) << 3)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_zpNBmm_bX ATL_zgpNBmm_bX
#endif

void ATL_zJIK40x0x40TN40x40x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK40x0x40TN40x40x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK40x0x40TN40x40x0_a1_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);

void ATL_zpNBmm_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc)
{
   ATL_zJIK40x0x40TN40x40x0_a1_bX(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_zJIK40x0x40TN40x40x0_a1_bX(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_zJIK40x0x40TN40x40x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_zJIK40x0x40TN40x40x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
